package de.jottyfan.bico.modules.ical;

import java.io.IOException;
import java.io.OutputStream;
import java.time.LocalDateTime;
import java.time.LocalTime;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import de.jottyfan.bico.db.public_.tables.records.VCalendarRecord;
import net.fortuna.ical4j.data.CalendarOutputter;
import net.fortuna.ical4j.model.Calendar;
import net.fortuna.ical4j.model.component.VEvent;
import net.fortuna.ical4j.validate.ValidationException;

/**
 *
 * @author jotty
 *
 */
@Service
public class IcalService {

	@Autowired
	private IcalRepository repository;

	public void createCalendar(OutputStream stream) throws ValidationException, IOException {
		Calendar calendar = new Calendar();
		CalendarOutputter out = new CalendarOutputter();
		for (VCalendarRecord record : repository.getAllDates()) {
			String summary = record.getFullname();
			LocalDateTime startEvent = LocalDateTime.of(record.getSlotDay(), LocalTime.of(10, 30));
			LocalDateTime endEvent = LocalDateTime.of(record.getSlotDay(), LocalTime.of(12, 0));
			VEvent event = new VEvent(startEvent, endEvent, summary);
			calendar.add(event);
		}
		out.output(calendar, stream);;
	}
}
