package de.jottyfan.bico.modules.lesson;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import de.jottyfan.bico.db.public_.tables.records.TLessonRecord;
import de.jottyfan.bico.modules.CommonController;
/**
 *
 * @author jotty
 *
 */
@Controller
public class LessonController extends CommonController {

	@Autowired
	private LessonService service;

	@GetMapping("/lesson")
	public String getPerson(@RequestParam("slotId") Integer slotId, Model model) {
		model.addAttribute("bean", service.getLesson(slotId, true));
		model.addAttribute("persons", service.getPersons());
		model.addAttribute("slotDay", service.getSlotDay(slotId));
		return "/lesson/item";
	}

	@PostMapping("/lesson/{id}")
	public String updateLesson(@PathVariable("id") Integer lessonId, @ModelAttribute("bean") TLessonRecord bean, Model model) {
		bean.setPkLesson(lessonId);
		service.updateLesson(bean);
		return "redirect:/sheet";
	}

	@GetMapping("/lesson/{id}/remove")
	public String removeLesson(@PathVariable("id") Integer lessonId) {
		service.removeLesson(lessonId);
		return "redirect:/sheet";
	}
}
